unit TweedeGraadsFunctie;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    Panel6: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Uit_f: TEdit;
    Uit_g: TEdit;
    Uit_a: TEdit;
    Uit_b: TEdit;
    Uit_c: TEdit;
    Uit_d: TEdit;
    Uit_1: TEdit;
    Uit_2: TEdit;
    Uit_3: TEdit;
    Uit_4: TEdit;
    Uit_5: TEdit;
    Uit_6: TEdit;
    Uit_7: TEdit;
    Uit_8: TEdit;
    Uit_9: TEdit;
    Uit_p: TEdit;
    KnopTekenG: TButton;
    KnopTekenP: TButton;
    KnopWisScherm: TButton;
    KnopStopGenereren: TButton;
    KnopRaaklijnenF: TButton;
    KnopNulpuntenNumeriek: TButton;
    KnopExtremeWaardeParaboolABCformule: TButton;
    KnopNulpuntenParaboolABCformule: TButton;
    KnopReset: TButton;
    KnopTekenF: TButton;
    KnopOppervlaktebepaling: TButton;
    KnopExtremeWaarden: TButton;
    KnopFunctiegenerator: TButton;
    ScrollBarDomein: TScrollBar;
    GroupBox1: TGroupBox;
    ScrollBarc: TScrollBar;
    ScrollBarb: TScrollBar;
    ScrollBara: TScrollBar;
    ScrollBard: TScrollBar;
    ScrollBarOndergrens: TScrollBar;
    ScrollBarBovengrens: TScrollBar;
    Tekengebied: TImage;
    KnopFix: TButton;
    GroupBox6: TGroupBox;
    Uit_v: TEdit;
    KnopRaaklijnenP: TButton;
    Uit_10: TEdit;
    procedure FormActivate(Sender: TObject);
    procedure KnopwisschermClick(Sender: TObject);
    procedure ScrollBaraScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure ScrollBarbScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure ScrollBarcScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure KnopResetClick(Sender: TObject);
    procedure KnopTekenFClick(Sender: TObject);
    procedure KnopNulpuntenNumeriekClick(Sender: TObject);
    procedure KnopExtremeWaardeParaboolABCformuleClick(Sender: TObject);
    procedure KnopNulpuntenParaboolABCformuleClick(Sender: TObject);
    procedure ScrollBardScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure KnopTekenGClick(Sender: TObject);
    procedure KnopFunctiegeneratorClick(Sender: TObject);
    procedure KnopStopGenererenClick(Sender: TObject);
    procedure KnopRaaklijnenFClick(Sender: TObject);
    procedure KnopExtremeWaardenClick(Sender: TObject);
    procedure KnopTekenPClick(Sender: TObject);
    procedure KnopOppervlaktebepalingClick(Sender: TObject);
    procedure ScrollBarOndergrensScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure ScrollBarBovengrensScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure ScrollBarDomeinScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure KnopFixClick(Sender: TObject);
    procedure KnopRaaklijnenPClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
       procedure ToonFunctievoorschriftBouwschema;
       procedure ToonFunctievoorschrift;
       procedure TekenAssenstelsel;
       procedure FunctiePlotten(k:char);
       procedure FunctieWissen(k:char);
       procedure wisscherm;
       procedure uitvoer;
       procedure wisuitvoer;
       procedure ExtremeWaardeParaboolABCformule;
       procedure NulpuntenParaboolABCformule;
       procedure ExtremeWaarden;
       procedure RaaklijnenPlotten(k:char);
       procedure OppervlakVullen(i:integer);
       function conversiex(x:real):integer;
       function conversiey(y:real):integer;
       function p(x:real):real;
       function f(x:real):real;
       function g(x:real):real;
       function r(x:real):real;
       function conI (i:integer): string;
       function conR (r:real): string;
  end;

const interval=0.001; pixx=965; pixy=640;  {696}
      x0=(pixx div 2); y0=(pixy div 2);

var
  Form1                                           : TForm1;
  stoppen                                         : boolean;
  gereset                                         : boolean;
  vastgezet                                       : boolean;
  dint,dmin,dmax                                  : integer;
  a,b,c,d,x,y,x1,x2,xo,xb,opp,xmax,ymax,dis,aa,bb : real;

implementation

{$R *.dfm}

function Tform1.p(x:real):real;
begin
   p:=(1/4)*d*x*x*x*x+(1/3)*a*x*x*x+(1/2)*b*x*x+c*x;
end; {De primitieve van f voor oppervlakteberekening}

function Tform1.f(x:real):real;
begin
   f:=(d*x*x*x)+(a*x*x)+(b*x)+c;
end; {De te onderzoeken functie f}

function Tform1.g(x:real):real;
begin
   g:=3*d*x*x+2*a*x+b;
end; {De afgeleide van f voor de richtingscoefficienten van de raaklijnen}

function Tform1.r(x:real):real;
begin
   r:=(aa*x)+bb;
end; {Functie voor de raaklijnen}

Procedure TForm1.ToonFunctievoorschriftBouwschema;
begin
  uit_p.text:='y ='#188+'dx^4'+'+1/3ax'+#179+'+'#189+'bx'+#178+'+cx';
  uit_f.text:='y =dx'+#179+'+ax'+#178+'+bx'+'+c';
  uit_g.text:='y =3dx'+#178+'+2ax'+'+b';
end;

Procedure TForm1.ToonFunctievoorschrift;
var t4,t1,t2,t3 : string[4];
    S4,S1,S2,S3 : string[20];
    g4,g1,g2,g3 : string[5];
    e4,e1,e2,e3 : string[4];
begin
   if d<0 then t4:='-';
   if d=0 then t4:=' ';
   if d>0 then t4:=' ';

   if a<0then t1:='-';
   if a=0 then t1:='+';
   if a>0 then t1:='+';

   if b<0 then t2:='-';
   if b=0 then t2:='+';
   if b>0 then t2:='+';

   if c<0 then t3:='-';
   if c=0 then t3:='+';
   if c>0 then t3:='+';

   if d>0 then g4:=conR(0.25*d);
   if d<0 then g4:=conR(-0.25*d);
   if a>0 then g1:=conR(0.33*a);
   if a<0 then g1:=conR(-0.33*a);
   if b>0 then g2:=conR(0.5*b);
   if b<0 then g2:=conR(-0.5*b);
   if c>0 then g3:=conR(c);
   if c<0 then g3:=conR(-c);

   if d=0 then e4:=' ' else e4:=' x^4';
   if a=0 then e1:=' ' else e1:=' x'+#179;
   if b=0 then e2:=' ' else e2:=' x'+#178;
   if c=0 then e3:=' ' else e3:=' x';

   S4:=t4+g4+e4;
   S1:=t1+g1+e1;
   S2:=t2+g2+e2;
   S3:=t3+g3+e3;

   Uit_p.Text:='y='+S4+S1+S2+S3;

   if d<0 then t4:=' ';
   if d=0 then t4:=' ';
   if d>0 then t4:=' ';

   if a<0 then t1:='-';
   if a=0 then t1:=' ';
   if a>0 then t1:='+';

   if b<0 then t2:='-';
   if b=0 then t2:=' ';
   if b>0 then t2:='+';

   if c<0 then t3:='-';
   if c=0 then t3:=' ';
   if c>0 then t3:='+';

   if d>0 then g4:=conR(d)else g4:=conR(-d);
   if a>0 then g1:=conR(a)else g1:=conR(-a);
   if b>0 then g2:=conR(b)else g2:=conR(-b);
   if c>0 then g3:=conR(c)else g3:=conR(-c);

   if d=0 then e4:=' ' else e4:='x'+#179;
   if a=0 then e1:=' ' else e1:='x'+#178;
   if b=0 then e2:=' ' else e2:='x';

   S4:=t4+g4+e4;
   S1:=t1+g1+e1;
   S2:=t2+g2+e2;
   S3:=t3+g3;

   Uit_f.Text:='y='+S4+S1+S2+S3;

   if d<0 then t4:='-';
   if d=0 then t4:=' ';
   if d>0 then t4:=' ';

   if a<0 then t1:='-';
   if a=0 then t1:=' ';
   if a>0 then t1:='+';

   if b<0 then t2:='-';
   if b=0 then t2:=' ';
   if b>0 then t2:='+';

   if d>0 then g4:=conR(3*d) else g4:=conR(-3*d);
   if a>0 then g1:=conR(2*a) else g1:=conR(-2*a);
   if b>0 then g2:=conR(b) else g2:=conR(-b);

   if d=0 then e4:=' ' else e4:='x'+#178;
   if a=0 then e1:=' ' else e1:='x';

   S4:=t4+g4+e4;
   S1:=t1+g1+e1;
   S2:=t2+g2;

   Uit_g.Text:='y='+S4+S1+S2;
end;

procedure TForm1.uitvoer;
begin
  Uit_a.text:='a = '+conR(a); Uit_b.text:='b = '+conR(b);
  Uit_c.text:='c = '+conR(c); Uit_d.text:='d = '+conR(d);
  Uit_6.text:=conR(xo); Uit_7.text:=conR(xb);
  if vastgezet then Uit_v.Text:='          fixed'
  else Uit_v.Text:='       not fixed';
end;

procedure TForm1.Wisuitvoer;
begin
 Uit_1.Text:=' '; Uit_2.Text:=' '; Uit_3.Text:=' ';
 Uit_4.Text:=' '; Uit_5.Text:=' '; Uit_6.Text:=' ';
 Uit_7.Text:=' '; Uit_8.Text:=' '; Uit_9.Text:=' ';
 Uit_10.Text:=' ';
end;

function TForm1.conI (i:integer): string;
begin
  conI:=IntToStr(i);
end;

function TForm1.conR (r:real): string;
begin
  conR:=FloatToStrF(r,ffFixed,1,2);
end;

procedure TForm1.NulpuntenParaboolABCformule;
begin
   if a<>0 then Dis:=((b*b)-(4*a*c));
   if ((Dis>=0) and (a<>0) and (d=0)) then
     begin
      x1:=(-b-sqrt(Dis))/(2*a);
      x2:=(-b+sqrt(Dis))/(2*a);
      Uit_1.Text:=conR(x1)+' '+conR(x2);
      Tekengebied.Canvas.TextOut(conversiex(x1),conversiey(0),conR(x1));
      Tekengebied.Canvas.TextOut(conversiex(x2),conversiey(0),conR(x2));
     end;
  if dis<0 then  Uit_1.Text:='D < 0';
  if a=0   then  Uit_1.Text:='a = 0';
  if d<>0  then Uit_1.Text:='D <> 0';
end;

procedure TForm1.RaaklijnenPlotten(k:char);
const dxx=0.05;
var   xx: real;
begin
  xx:=dmin;
   if k='f' then Tekengebied.Canvas.Pen.Color:=clPurple;
   if k='p' then Tekengebied.Canvas.Pen.Color:=clOlive;
   while ((xx<=dmax) and (not stoppen)) do
   begin
    if k='f' then begin aa:=g(xx); bb:=f(xx)-(xx*g(xx)); end;
    if k='p' then begin aa:=f(xx); bb:=p(xx)-(xx*f(xx)); end;
    Tekengebied.Canvas.MoveTo(conversiex(dmin),conversiey(r(dmin)));
    Tekengebied.Canvas.LineTo(conversiex(dmax),conversiey(r(dmax)));
    sleep(1);
    xx:=xx+dxx;
    if k='f' then Uit_9.Text:='y = '+conR(aa)+'x '+conR(bb);
    if k='p' then Uit_10.Text:='y = '+conR(aa)+'x '+conR(bb);
    application.processmessages;
   end;
end;

procedure TForm1.TekenAssenstelsel;
var i : integer;
begin
  Tekengebied.Canvas.Pen.Color:=clBlack;
  Tekengebied.Canvas.MoveTo(0,(pixy div 2));
  Tekengebied.Canvas.LineTo(pixx,pixy div 2);
  Tekengebied.Canvas.MoveTo(pixx div 2,0);
  Tekengebied.Canvas.LineTo(pixx div 2,pixy);
  Tekengebied.Canvas.MoveTo(pixx-1,0);
  Tekengebied.Canvas.LineTo(pixx-1,pixx+pixy);
  Tekengebied.Canvas.MoveTo(0,pixy-1);
  Tekengebied.Canvas.LineTo(pixx,pixy-1);
  Tekengebied.Canvas.TextOut(pixx-30,(pixy div 2)+3,'x ['+conI(dmax)+']');
  Tekengebied.Canvas.TextOut((pixx div 2)+5,5,'y ['+conI(dmax)+']');
end;

procedure TForm1.wisscherm;
begin
  Tekengebied.Canvas.Brush.Color:=clWhite;
  Tekengebied.Canvas.Rectangle(0,0,pixx+9,pixy+9);
  Tekengebied.Canvas.Refresh; TekenAssenstelsel;
end;

function TForm1.conversiex(x:real):integer;
var p:integer; Sx: real;
begin
 Sx:=pixx div (dmax-dmin);
 conversiex:=x0+ROUND(x*Sx);
end;

function TForm1.conversiey(y:real):integer;
var q:integer; Sy:real;
begin
 Sy:=(pixy div 2) div dmax;
 conversiey:=y0-ROUND(y*Sy);
end;

procedure TForm1.FunctiePlotten(k:char);
begin
  x:=dmin;
  if k='p' then begin y:=p(x); Tekengebied.Canvas.MoveTo(conversiex(x),conversiey(p(x))); end;
  if k='f' then begin y:=f(x); Tekengebied.Canvas.MoveTo(conversiex(x),conversiey(f(x))); end;
  if k='g' then begin y:=g(x); Tekengebied.Canvas.MoveTo(conversiex(x),conversiey(g(x))); end;
  if ((d<>0) or (a<>0)) then
   if k='r' then begin y:=r(x); Tekengebied.Canvas.MoveTo(conversiex(x),conversiey(r(x))); end;
  While ((x<=dmax) and (not stoppen)) do
    begin
     if k='p' then begin y:=p(x); Tekengebied.Canvas.LineTo(conversiex(x),conversiey(p(x))); Tekengebied.Canvas.Pen.Color:=clOlive;  end;
     if k='f' then begin y:=f(x); Tekengebied.Canvas.LineTo(conversiex(x),conversiey(f(x))); Tekengebied.Canvas.Pen.Color:=clPurple; end;
     if k='g' then begin y:=g(x); Tekengebied.Canvas.LineTo(conversiex(x),conversiey(g(x))); Tekengebied.Canvas.Pen.Color:=clRed;    end;
     if ((d<>0) or (a<>0)) then
     if k='r' then begin y:=r(x); Tekengebied.Canvas.LineTo(conversiex(x),conversiey(r(x))); Tekengebied.Canvas.Pen.Color:=clRed  ; end;
     x:=x+interval;
    end;
  ToonFunctievoorschrift;
end;

procedure TForm1.FunctieWissen(k:char);
begin
 if ((a<>0) or (b<>0) or (c<>0) or (d<>0)) then
  begin
   x:=dmin;
   if k='p' then begin y:=p(x); Tekengebied.Canvas.MoveTo(conversiex(x),conversiey(p(x))); end;
   if k='f' then begin y:=f(x); Tekengebied.Canvas.MoveTo(conversiex(x),conversiey(f(x))); end;
   if k='g' then begin y:=g(x); Tekengebied.Canvas.MoveTo(conversiex(x),conversiey(g(x))); end;
   if ((d<>0) or (a<>0)) then
    if k='r' then begin y:=r(x); Tekengebied.Canvas.MoveTo(conversiex(x),conversiey(r(x))); end;
   While ((x<=dmax) and (not stoppen)) do
     begin
      if k='p' then begin y:=p(x); Tekengebied.Canvas.LineTo(conversiex(x),conversiey(p(x))); Tekengebied.Canvas.Pen.Color:=clWhite;  end;
      if k='f' then begin y:=f(x); Tekengebied.Canvas.LineTo(conversiex(x),conversiey(f(x))); Tekengebied.Canvas.Pen.Color:=clWhite; end;
      if k='g' then begin y:=g(x); Tekengebied.Canvas.LineTo(conversiex(x),conversiey(g(x))); Tekengebied.Canvas.Pen.Color:=clWhite;    end;
      if ((d<>0) or (a<>0)) then
      if k='r' then begin y:=r(x); Tekengebied.Canvas.LineTo(conversiex(x),conversiey(r(x))); Tekengebied.Canvas.Pen.Color:=clWhite; end;
      x:=x+interval;
     end;
   ToonFunctievoorschrift;
 end;
end;

procedure TForm1.OppervlakVullen(i:integer);
const dx=0.01;
begin
  x:=xo;
  if i=1 then Tekengebied.Canvas.Pen.Color:=clGreen;
  if i=0 then Tekengebied.Canvas.Pen.Color:=clWhite;
  While ((x<=xb) and (not stoppen)) do
    begin
     y:=f(x);
     Tekengebied.Canvas.MoveTo(conversiex(x),conversiey(0));
     Tekengebied.Canvas.LineTo(conversiex(x),conversiey(y));
     sleep(0);
     x:=x+dx;
     Uit_8.Text:=conR(p(x)-p(xo));
     application.processmessages;
    end;
end;

procedure TForm1.KnopNulpuntenParaboolABCformuleClick(Sender: TObject);
begin
  NulpuntenParaboolABCformule;
end;

procedure TForm1.ExtremeWaardeParaboolABCformule;
begin
  if ((a<>0) and (d=0)) then
    begin
     ymax:=f(-b/(2*a));
     Uit_2.Text:=conR(-b/(2*a))+'  '+conR(ymax);
     Tekengebied.Canvas.TextOut(conversiex(-b/(2*a)),conversiey(ymax),conR(-b/(2*a))+' '+(conR(ymax)));
    end else
  if a=0 then Uit_2.Text:='a = 0';
  if d<>0 then Uit_2.Text:='D <> 0';
end;

procedure TForm1.KnopExtremeWaardeParaboolABCformuleClick(Sender: TObject);
begin
 ExtremeWaardeParaboolABCformule;
end;

procedure TForm1.KnopNulpuntenNumeriekClick(Sender: TObject);
const                                       max=100;
type             NulpuntenGeheugen=array[1..max] of real;
var N          : NulpuntenGeheugen;
    Ns         : string;
    x,y,dx,m   : real;
    i          : integer;
begin
 wisscherm;
 for i:=1 to max do N[i]:=-111;
 i:=1; dx:=0.01; m:=5*dx; x:=dmin; Ns:=' ';
 while x<=dmax do
  begin
    y:=f(x);
    if ((y>-m) and (y<m)) then
      begin
       N[i]:=x; inc(i); Ns:=Ns+conR(x)+' ';
      end;
    x:=x+dx;
  end;
  Uit_4.text:=' '+conI(i-1); Uit_5.text:=Ns; FunctiePlotten('f');
end;

procedure TForm1.KnopRaaklijnenFClick(Sender: TObject);
begin
  RaaklijnenPlotten('f');
end;

procedure TForm1.KnopRaaklijnenPClick(Sender: TObject);
begin
  RaaklijnenPlotten('p');
end;

procedure TForm1.KnopFunctiegeneratorClick(Sender: TObject);
const max=4;
begin
 stoppen:=false;
 while not stoppen do
  begin
   wisscherm; Randomize;
   d:=Random(max)- (max div 2);
   a:=Random(max)- (max div 2);
   b:=Random(max)- (max div 2);
   c:=Random(max)- (max div 2);
   uitvoer;
   FunctiePlotten('f'); FunctiePlotten('g'); FunctiePlotten('p');
   OppervlakVullen(1);
   OppervlakVullen(0);
   FunctiePlotten('f');
   FunctiePlotten('g');
   FunctiePlotten('p');
   TekenAssenstelsel;
   if ((a<>0) or (d<>0)) then
    begin
     RaaklijnenPlotten('f');
     WisScherm;
     FunctiePlotten('f');
     FunctiePlotten('g');
     FunctiePlotten('p');
     RaaklijnenPlotten('p');
    end;
   sleep(350); wisuitvoer;
   FunctieWissen('f');
   FunctieWissen('g');
   FunctieWissen('p');
   TekenAssenstelsel;
  end;
 stoppen:=false;
end;

procedure TForm1.ExtremeWaarden;
var dis,aa,bb,cc,x1,x2,y1,y2: real;
begin
   if d<>0 then
    begin
      aa:=3*d; bb:=2*a; cc:=b;
      if aa<>0 then dis:=((bb*bb)-(4*aa*cc));
      if ((dis>=0) and (aa<>0)) then
       begin
        x1:=(-bb-sqrt(dis))/(2*aa); y1:=f(x1);
        x2:=(-bb+sqrt(dis))/(2*aa); y2:=f(x2);
       end;
      if dis>=0 then
       begin
        Uit_3.Text:=conR(x1)+' '+conR(y1)+'   '+conR(x2)+' '+conR(y2);
        Tekengebied.Canvas.TextOut(conversiex(x1),conversiey(y1),conR(x1)+' '+conR(y1));
        Tekengebied.Canvas.TextOut(conversiex(x2),conversiey(y2),conR(x2)+' '+conR(y2));
       end;
       if dis<0 then Uit_3.Text:='... geen gevonden ..';
    end;

   if ((d=0) and (a<>0)) then
    begin
     aa:=a; bb:=b;
     x1:=-bb/(2*aa); y1:=f(x1);
     Uit_3.Text:=conR(x1)+' '+conR(y1);
    end;
end;

procedure TForm1.KnopExtremeWaardenClick(Sender: TObject);
begin
 ExtremeWaarden;
end;

procedure TForm1.KnopStopGenererenClick(Sender: TObject);
begin
  stoppen:=not stoppen;
end;

procedure TForm1.KnopTekenPClick(Sender: TObject);
begin
  stoppen:=false; vastgezet:=false; Uitvoer; FunctiePlotten('p');
end;

procedure TForm1.KnopTekenFClick(Sender: TObject);
begin
  stoppen:=false; vastgezet:=false; Uitvoer; FunctiePlotten('f');
end;

procedure TForm1.KnopTekenGClick(Sender: TObject);
begin
  stoppen:=false; vastgezet:=false; Uitvoer; FunctiePlotten('g');
end;

procedure TForm1.KnopwisschermClick(Sender: TObject);
begin
  wisscherm; stoppen:=true;
end;

procedure TForm1.KnopResetClick(Sender: TObject);
begin
  d:=0; a:=0; b:=0; c:=0;
  wisuitvoer; gereset:=true;
  ToonFunctievoorschriftBouwschema;
end;

procedure TForm1.KnopFixClick(Sender: TObject);
begin
 vastgezet:=not vastgezet; uitvoer;
end;

procedure TForm1.KnopOppervlaktebepalingClick(Sender: TObject);
begin
 OppervlakVullen(1);
end;

procedure TForm1.ScrollBarOndergrensScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
 xo:=ScrollPos; xo:=xo/10; uit_6.text:=conR(xo);
end;

procedure TForm1.ScrollBarBovengrensScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  xb:=ScrollPos; xb:=xb/10; uit_7.text:=conR(xb);
end;

procedure TForm1.ScrollBardScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if vastgezet then FunctieWissen('f');
  if gereset then ScrollPos:=round(d);
  d:=ScrollPos; d:=d/10; Uitvoer;
  if vastgezet then FunctiePlotten('f');
  gereset:=false; ToonFunctievoorschrift;
end;

procedure TForm1.ScrollBaraScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if vastgezet then FunctieWissen('f');
  if gereset then ScrollPos:=round(a);
  a:=ScrollPos; a:=a/10; Uitvoer;
  if vastgezet then FunctiePlotten('f');
  gereset:=false; ToonFunctievoorschrift;
end;

procedure TForm1.ScrollBarbScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if vastgezet then FunctieWissen('f');
  if gereset then ScrollPos:=round(b);
  b:=ScrollPos; b:=b/10; Uitvoer;
  if vastgezet then FunctiePlotten('f');
  gereset:=false; ToonFunctievoorschrift;
end;

procedure TForm1.ScrollBarcScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if vastgezet then FunctieWissen('f');
  if gereset then ScrollPos:=round(c);
  c:=ScrollPos; c:=c/10; Uitvoer;
  if vastgezet then FunctiePlotten('f');
  gereset:=false; ToonFunctievoorschrift;
end;

procedure TForm1.ScrollBarDomeinScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  FunctieWissen('f');
  dint:=ScrollPos; dmin:=-dint div 2; dmax:=-dmin;
  TekenAssenstelsel; FunctiePlotten('f'); stoppen:=false;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 application.processmessages;
 Tekengebied.Height:=pixy;
 Tekengebied.Width:=pixx;
 Tekengebied.Canvas.Font.Size:=8;
 Tekengebied.Canvas.Pen.Width:=1;
 stoppen:=false; gereset:=false; vastgezet:=false;
 dint:=10; dmin:=-dint div 2; dmax:=-dmin;
 d:=0; Uit_d.Text:=conR(d);
 a:=0; Uit_a.Text:=conR(a);
 b:=0; Uit_b.Text:=conR(b);
 c:=0; Uit_c.Text:=conR(c);
 xo:=0; Uit_6.Text:=conR(xo);
 xb:=0; Uit_7.Text:=conR(xb);
 ToonFunctievoorschriftBouwschema; wisscherm; uitvoer;
end;

end.
